#include "firmware.h" /* NEEDS CORRECT FIRMWARE VERSION! */

typedef unsigned  long _ulong;
typedef unsigned   int _uint;
typedef unsigned short _ushort;
typedef unsigned  char _uchar, _byte;

typedef struct {
  _ushort stamp;
  short sample[4];
} struct_sample4;

typedef struct {
  _byte phase, mult1, mult2;
} struct_wave;

typedef struct {
  _ushort attack, sustain;
  _byte shift, shift_mode;
} struct_envel;

/* API CALLS START HERE */

extern  int Board_Init(void);
extern void Board_Reset(void);
extern void Board_GetVersionInfo(char *info_a, char *info_b);
extern void Board_GetGlob(struct_glob *glob_ptr_a,
			  struct_glob *glob_ptr_b);
extern void Board_GetSamples(_ushort sample_num,
			     struct_sample4 *sample4_array);
extern void Board_GetState(enum_ENV *state_a_ptr, enum_ENV *state_b_ptr);
/* phase: 0~31, mult1 & mult2: 0~7 */
extern void Board_SetWave(struct_wave *wave_ptr_a,
			  struct_wave *wave_ptr_b);
extern void Board_SetEnvelope(struct_envel *env_a_ptr,
			      struct_envel *env_b_ptr);
extern void Board_SetDebug(enum_DEB deb[4]);
extern void Board_SetSteps(short step[4]);
extern void Board_SetFreq(_byte freq);
extern void Board_SetOnMode(enum_ON_MODE mode_a, enum_ON_MODE mode_b);
extern void Board_Off(void);
extern void Board_On(void);


